$(document).ready(function() {
	var texte = readCookie("algorithme");

	if(texte == "failed")
		document.location.href="algo_soumis.php";

	while(texte.indexOf("@") != -1)
		texte = texte.replace("@",";");
	
	var balises = [	
		"<font", "</font",	
		"<p", "</p",	
		"<a", "</a",
		"<b", "</b",
		"<i", "</i",
		"<u", "</u",
		"<br ",
		"<div ",
		"<span ",
	];
		
	while(texte.indexOf("&nbsp;") != -1)
		texte = texte.replace("&nbsp;","");
	
	for(var k = 0; k < 15; k++)
	{
		while(texte.indexOf(balises[k]) != -1)
		{
			var start, end;
			start = texte.indexOf(balises[k], 0);
			end = texte.indexOf(">", start);
			
			if(start != -1 && end != -1)
			{
				if(k < 13)
					texte = texte.substring(0, start) + texte.substring(end + 1, texte.length);
				else
					texte = texte.substring(0, start) + balises[k].substring(0, balises[k].length - 1) + ">" + texte.substring(end + 1, texte.length);
			}
		}
	}
	
	while(texte.indexOf("<span>") != -1)
		texte = texte.replace("<span>","<div>");
		
	while(texte.indexOf("</span>") != -1)
		texte = texte.replace("</span>","</div>");
		
	$('#code').replaceWith("<div id='code'>" + texte + "</div>");
	
	while(texte.indexOf(";") != -1)
		texte = texte.replace(";","@");
		
	while(texte.indexOf("+") != -1)
		texte = texte.replace("+","¤");

	createCookie("algo",texte,1);
});

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}


function createCookie(name,value,days) {
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	}
	else var expires = "";
	document.cookie = name+"="+value;
}
		